import { resource } from "./instructions.js";
export function useAbortSignal() {
    return resource(function* AbortSignal(provide) {
        let controller = new AbortController();
        try {
            yield* provide(controller.signal);
        }
        finally {
            controller.abort();
        }
    });
}
//# sourceMappingURL=abort-signal.js.map