import { action, suspend } from "./instructions.js";
export function expect(promise) {
    return action(function* (resolve, reject) {
        promise.then(resolve, reject);
        yield* suspend();
    });
}
export function subscribe(iter) {
    return {
        [Symbol.iterator]: () => expect(iter.next())[Symbol.iterator](),
    };
}
export function stream(iterable) {
    return {
        *[Symbol.iterator]() {
            return subscribe(iterable[Symbol.asyncIterator]());
        },
    };
}
//# sourceMappingURL=async.js.map