import { action, resource, suspend } from "./instructions.js";
export function createChannel() {
    let subscribers = new Set();
    let output = {
        [Symbol.iterator]: () => resource(function* (provide) {
            let subscriber = {
                notify() { },
            };
            let subscription = {
                [Symbol.iterator]: () => action(function* (resolve) {
                    subscriber.notify = resolve;
                    yield* suspend();
                })[Symbol.iterator](),
            };
            subscribers.add(subscriber);
            try {
                yield* provide(subscription);
            }
            finally {
                subscribers.delete(subscriber);
            }
        })[Symbol.iterator](),
    };
    let send = (item) => {
        return action(function* (resolve, reject) {
            yield* [{
                    type: "suspend",
                    then() {
                        let result = { type: "resolved", value: void 0 };
                        for (let subscriber of subscribers) {
                            try {
                                subscriber.notify(item);
                            }
                            catch (error) {
                                result = { type: "rejected", error };
                            }
                        }
                        if (result.type === "rejected") {
                            reject(result.error);
                        }
                        else {
                            resolve(result.value);
                        }
                    },
                }];
        });
    };
    let input = {
        send: (value) => send({ done: false, value }),
        close: (value) => send({ done: true, value }),
    };
    return { input, output };
}
//# sourceMappingURL=channel.js.map