import { createYSEnv, global, parse } from "./evaluate.js";
import { concat, createPSMap } from "./psmap.js";
import { load } from "./load.js";
import { run } from "./deps.js";
export function createPlatformScript(extensions) {
    let ext = extensions ?? createPSMap();
    let env = createYSEnv(concat(global, ext));
    return {
        eval(value, bindings) {
            return run(() => env.eval(value, bindings));
        },
        load(location, base) {
            return run(() => load({ location, base, env }));
        },
        parse(source, filename) {
            return parse(source, filename);
        },
    };
}
//# sourceMappingURL=platformscript.js.map