"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAbortSignal = void 0;
const instructions_js_1 = require("./instructions.js");
function useAbortSignal() {
    return (0, instructions_js_1.resource)(function* AbortSignal(provide) {
        let controller = new AbortController();
        try {
            yield* provide(controller.signal);
        }
        finally {
            controller.abort();
        }
    });
}
exports.useAbortSignal = useAbortSignal;
//# sourceMappingURL=abort-signal.js.map