"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stream = exports.subscribe = exports.expect = void 0;
const instructions_js_1 = require("./instructions.js");
function expect(promise) {
    return (0, instructions_js_1.action)(function* (resolve, reject) {
        promise.then(resolve, reject);
        yield* (0, instructions_js_1.suspend)();
    });
}
exports.expect = expect;
function subscribe(iter) {
    return {
        [Symbol.iterator]: () => expect(iter.next())[Symbol.iterator](),
    };
}
exports.subscribe = subscribe;
function stream(iterable) {
    return {
        *[Symbol.iterator]() {
            return subscribe(iterable[Symbol.asyncIterator]());
        },
    };
}
exports.stream = stream;
//# sourceMappingURL=async.js.map