"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPlatformScript = void 0;
const evaluate_js_1 = require("./evaluate.js");
const psmap_js_1 = require("./psmap.js");
const load_js_1 = require("./load.js");
const deps_js_1 = require("./deps.js");
function createPlatformScript(extensions) {
    let ext = extensions ?? (0, psmap_js_1.createPSMap)();
    let env = (0, evaluate_js_1.createYSEnv)((0, psmap_js_1.concat)(evaluate_js_1.global, ext));
    return {
        eval(value, bindings) {
            return (0, deps_js_1.run)(() => env.eval(value, bindings));
        },
        load(location, base) {
            return (0, deps_js_1.run)(() => (0, load_js_1.load)({ location, base, env }));
        },
        parse(source, filename) {
            return (0, evaluate_js_1.parse)(source, filename);
        },
    };
}
exports.createPlatformScript = createPlatformScript;
//# sourceMappingURL=platformscript.js.map