"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exclude = exports.lookup$ = exports.lookup = exports.map = exports.concat = exports.createPSMap = void 0;
function createPSMap() {
    return {
        type: "map",
        value: new Map(),
    };
}
exports.createPSMap = createPSMap;
function concat(parent, child) {
    return {
        type: "map",
        value: new Map([...parent.value.entries(), ...child.value.entries()]),
    };
}
exports.concat = concat;
function* map(fntor, fn) {
    let entries = [];
    for (let [k, v] of fntor.value.entries()) {
        entries.push([k, yield* fn(v)]);
    }
    return { type: "map", value: new Map(entries) };
}
exports.map = map;
function lookup(key, map) {
    for (let entry of map.value.entries()) {
        let [k, value] = entry;
        if (k.value.toString() === key) {
            return { type: "just", value };
        }
    }
    return { type: "nothing", value: void 0 };
}
exports.lookup = lookup;
function lookup$(key, map) {
    let maybe = lookup(key, map);
    if (maybe.type === "nothing") {
        throw new Error(`expected map to contain key '${key}', but it did not`);
    }
    return maybe.value;
}
exports.lookup$ = lookup$;
function exclude(keys, map) {
    return {
        type: "map",
        value: new Map({
            *[Symbol.iterator]() {
                for (let [key, value] of map.value.entries()) {
                    if (!keys.includes(key.value.toString())) {
                        yield [key, value];
                    }
                }
            },
        }),
    };
}
exports.exclude = exclude;
//# sourceMappingURL=psmap.js.map