import type { Operation } from "./types.js";
import { resource } from "./instructions.js";

export function useAbortSignal(): Operation<AbortSignal> {
  return resource(function* AbortSignal(provide) {
    let controller = new AbortController();
    try {
      yield* provide(controller.signal);
    } finally {
      controller.abort();
    }
  });
}
