import type { Operation } from "./types.js";
import { action, suspend } from "./instructions.js";

export function sleep(duration: number): Operation<void> {
  return action(function* sleep(resolve) {
    let timeoutId = setTimeout(resolve, duration);
    try {
      yield* suspend();
    } finally {
      clearTimeout(timeoutId);
    }
  });
}
