import type { YAMLNode } from "./deps.js";
import { PSLiteral, PSRef, PSValue } from "./types.js";
/**
 * Convert a JavaScript value into a PlatformScript value
 */
export declare function js2ps(value: unknown): PSValue;
/**
 * Convert a PlatformScript value into a JavaScript value
 */
export declare function ps2js(value: PSValue): unknown;
export interface RefHole {
    ref: PSRef;
    range: [number, number];
}
export interface RefMatch {
    total: boolean;
    holes: RefHole[];
}
export declare function matchRefs(value: string): RefMatch;
/**
 * Convert source YAML into a PlatformScript Literal
 */
export declare function yaml2ps(node: YAMLNode): PSLiteral<PSValue>;
