import type { Future } from "./types.js";
export declare type Result<T = unknown> = {
    type: "resolved";
    value: T;
} | {
    type: "rejected";
    error: Error;
};
export interface NewFuture<T> {
    resolve(value: T): void;
    reject(error: Error): void;
    future: Future<T>;
}
export declare function createFuture<T>(): NewFuture<T>;
